import { ExtractPropTypes, PropType, DefineComponent, Ref } from "vue";
import { CSSProperties } from "vue";
export interface Component {
    name?: string;
    render?(): void;
    __file?: string;
}
export interface CustomElement {
    el: string;
    vIf?: boolean;
    "v-if"?: boolean;
    style?: CSSProperties;
    slot?: string;
    deepSlot?: string;
    children?: (CustomElement | DefineComponent)[] | string | DefineComponent | CustomElement | Ref<any>;
    [prop: string]: any;
}
export declare const customElementProps: {
    readonly list: {
        readonly type: PropType<CustomElement | DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{}>>, {}> | (CustomElement | DefineComponent<{}, {}, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{}>>, {}>)[]>;
        readonly default: () => never[];
    };
};
export declare type CustomElementProps = ExtractPropTypes<typeof customElementProps>;
