import { defineComponent as $, computed as B, ref as C, shallowRef as T, onMounted as I, watch as L, createVNode as n, resolveComponent as O, mergeProps as m, toRef as N, unref as q, Fragment as z, nextTick as G, isVNode as H } from "vue";
import { formProps as J, formEmits as Q } from "./props.js";
import { dialogProps as W, dialogEmits as X, ElFormItem as w, ElCol as _ } from "element-plus";
import { pickObjByKeys as v, firstUppercase as Y, deepClone as Z, omitObjByKeys as ee } from "@tomiaa/utils";
import { KCustomElement as g } from "../../customElement/index.js";
import { Toolbar as oe, Editor as le } from "@wangeditor/editor-for-vue";
import "../../node_modules/.pnpm/@wangeditor_editor@5.1.18/node_modules/@wangeditor/editor/dist/css/style.js";
function te(o) {
  return typeof o == "function" || Object.prototype.toString.call(o) === "[object Object]" && !H(o);
}
const fe = $({
  name: "KForm",
  props: J,
  emits: Q,
  setup(o, {
    attrs: d,
    slots: f,
    emit: s,
    expose: D
  }) {
    const b = o.modelValue !== void 0, F = ["", !1].includes(d.inline), K = B(() => v(o, Object.keys(W))), j = {};
    for (const e in X)
      j["on" + Y(e)] = () => s(e);
    const u = C(), S = () => {
      var e;
      return n(O("el-dialog"), m({
        ref: u
      }, j, {
        "onUpdate:modelValue": (l) => s("update:modelValue", l),
        onClosed: o.destroyOnClose && ((e = r.value) == null ? void 0 : e.resetFields)
      }, K.value), {
        footer: o.showActions ? k : void 0,
        ...f,
        default: R
      });
    }, k = () => {
      var l, a, i, M;
      let e = [{
        el: "el-button",
        type: "primary",
        "v-if": o.actionsConfig.showSubmit,
        onClick() {
          var A, P;
          const c = {
            formRef: r,
            dialogRef: u,
            formModel: t,
            validate: (A = r.value) == null ? void 0 : A.validate,
            rawFormModel: h()
          };
          if (o.autoValidateOnSubmit) {
            (P = r.value) == null || P.validate((x) => {
              s(x ? "submit" : "submitCheckFail", c);
            });
            return;
          }
          s("submit", c);
        },
        children: (l = o.actionsConfig.submitText) != null ? l : "\u63D0\u4EA4"
      }, {
        el: "el-button",
        "v-if": o.actionsConfig.showReset,
        onClick() {
          var c;
          r.value.resetFields(), s("reset", {
            formRef: r,
            dialogRef: u,
            formModel: t,
            validate: (c = r.value) == null ? void 0 : c.validate,
            rawFormModel: h()
          });
        },
        children: (a = o.actionsConfig.resetText) != null ? a : "\u91CD\u7F6E"
      }, {
        el: "el-button",
        "v-if": o.actionsConfig.showCancel,
        onClick() {
          s("update:modelValue", !1), s("cancel");
        },
        children: (i = o.actionsConfig.cancelText) != null ? i : "\u53D6\u6D88"
      }];
      return (M = o.actionsConfig) != null && M.custom && (e = o.actionsConfig.custom(e)), b ? n(g, {
        list: e
      }, null) : F ? n(w, null, {
        default: () => [n(g, {
          list: e
        }, null)]
      }) : n(_, o.actionsConfig, {
        default: () => [n(w, null, {
          default: () => [n(g, {
            list: e
          }, null)]
        })]
      });
    }, r = C(), t = C(d.model || {}), V = () => {
      o.options.forEach((e) => {
        if (e.prop && typeof e.prop == "string") {
          const l = e.el === "el-upload" ? "fileList" : "modelValue";
          t.value[e.prop] = N(e, l);
        }
      });
    };
    V();
    const h = () => {
      const e = {};
      for (const l in t.value)
        e[l] = q(t.value[l]);
      return e;
    }, R = () => n(O("el-form"), m(d, {
      ref: r,
      model: t.value
    }), {
      default: () => [n(O("el-row"), d, {
        default: () => [o.options.map((e) => {
          const l = e.el === "el-upload" ? "fileList" : "modelValue";
          let a = {
            ...v(e, Object.keys(_.props)),
            class: e.class ? `${e.class}__el-col` : "",
            el: "el-col",
            children: {
              ...v(e, Object.keys(w.props)),
              class: e.class ? `${e.class}__el-form-item` : "",
              el: "el-form-item",
              children: {
                ...e,
                [l]: t.value[e.prop],
                [`onUpdate:${l}`](i) {
                  Object.prototype.hasOwnProperty.call(t.value, e.prop) && (t.value[e.prop] = i);
                }
              }
            }
          };
          return F && (a = a.children), e.el === "editor" && (a.children.children = U(e)), n(g, {
            list: a
          }, te(f) ? f : {
            default: () => [f]
          });
        }), o.showActions && !b && k()]
      })]
    }), p = T({}), U = (e) => (e.prop && !p.value[e.prop] && (p.value[e.prop] = T()), n(z, null, [n(oe, m({
      style: "border-bottom: 1px solid #ccc",
      mode: "default",
      editor: e.prop && p.value[e.prop].value
    }, e.editorAttrs), null), n(le, m({
      style: "height: 300px; width: 100%; overflow-y: hidden",
      mode: "default",
      modelValue: t.value[e.prop],
      "onUpdate:model-value": (l) => {
        Object.prototype.hasOwnProperty.call(t.value, e.prop) && (t.value[e.prop] = l);
      },
      onOnCreated: (l) => {
        e.prop && (p.value[e.prop].value = l);
      }
    }, e.toolbarAttrs), null)])), y = {
      initFormModel: V,
      getRawFormModel: h,
      setFormModel: (e, {
        includes: l = [],
        exclude: a = []
      } = {}) => {
        e = Z(e);
        let i = l != null && l.length ? v(e, l) : e;
        a != null && a.length && (i = ee(i, a)), Object.assign(t.value, i);
      },
      getFormRef: () => r,
      getDialogRef: () => u,
      formModel: t
    }, E = async () => {
      await G(), Object.assign(y, r.value), Object.assign(y, u.value);
    };
    return I(E), L(() => o.modelValue, E), D(y), () => n("div", null, [b ? S() : R()]);
  }
});
export {
  fe as default
};
