import { defineComponent as ee, ref as d, onMounted as M, withDirectives as te, createVNode as o, mergeProps as G, resolveComponent as y, resolveDirective as ae, nextTick as $, isVNode as le, toRef as N, Fragment as ie } from "vue";
import ue from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as J } from "../../customElement/index.js";
import "../../form/index.js";
import { tableProps as ne, tableEmits as oe } from "./props.js";
import { Check as re, Close as de, Edit as ce } from "@element-plus/icons-vue";
import { createNamespacs as me, getValue as A } from "@tomiaa/utils";
import "../../packages/theme-chalk/lib/vue3-components/table.js";
function ve(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !le(e);
}
const P = me("table"), Re = ee({
  name: "KTable",
  props: ne,
  emits: oe,
  setup(e, {
    attrs: S,
    slots: k,
    emit: m,
    expose: H
  }) {
    const L = d(""), O = d(""), {
      append: _,
      empty: B = () => e.emptyTip && T.value && L.value,
      page: W,
      editControlIcon: R,
      editIcon: Q
    } = k, s = d({}), h = d({}), X = (c) => c == null ? void 0 : c.map((z) => {
      const {
        slot: E,
        action: w,
        actionConfig: t,
        editable: V,
        editableConfig: u,
        ...f
      } = z, v = {
        header: k.header,
        default: E && k[E]
      };
      if (e.editRow && (v.default = (l) => {
        const {
          row: i,
          column: a,
          $index: r
        } = l;
        return o("div", {
          class: [P.e("editable"), P.is("editable", s.value[r])]
        }, [s.value[r] ? o(y("el-input"), {
          size: "small",
          modelValue: h.value[r][a.property],
          "onUpdate:modelValue": (g) => h.value[r][a.property] = g
        }, null) : i[a.property]]);
      }), (w || t) && (v.default = (l) => {
        const {
          $index: i,
          row: a
        } = l;
        let r = [{
          el: "el-button",
          size: "small",
          "v-if": t == null ? void 0 : t.showEdit,
          onClick: () => {
            if (e.editRow) {
              if (s.value[i]) {
                Object.assign(l.row, h.value[i]), delete h.value[i], delete s.value[i], m("confirmEditRow", l);
                return;
              }
              h.value[i] = JSON.parse(JSON.stringify(a)), s.value[i] = !0;
            }
            m("edit", l);
          },
          children: s.value[i] ? "\u786E\u5B9A" : (t == null ? void 0 : t.editText) || "\u7F16\u8F91"
        }, {
          el: "el-button",
          size: "small",
          type: "danger",
          "v-if": t == null ? void 0 : t.showDelete,
          onClick: () => {
            if (e.editRow) {
              delete h.value[i], delete s.value[i], m("cancelEditRow", l);
              return;
            }
            m("delete", l);
          },
          children: s.value[i] ? "\u53D6\u6D88" : (t == null ? void 0 : t.deleteText) || "\u5220\u9664"
        }];
        return t != null && t.custom && (r = t.custom(r, l)), o(J, {
          list: r
        }, null);
      }), V || u) {
        const l = d({}), i = d({});
        v.default = (a) => {
          const {
            row: r,
            column: g,
            $index: Z
          } = a, n = g.id + Z, K = () => {
            delete i.value[n], delete l.value[n];
          };
          let j = [{
            el: "el-icon",
            color: "var(--el-color-success)",
            size: "1.2em",
            "v-if": u == null ? void 0 : u.showEnter,
            onClick() {
              r[g.property] = i.value[n], K(), m("confirmEditCell", a);
            },
            children: re
          }, {
            el: "el-icon",
            size: "1.2em",
            color: "var(--el-color-danger)",
            "v-if": u == null ? void 0 : u.showClose,
            onClick() {
              K(), m("cancelEditCell", a);
            },
            children: de
          }];
          return u != null && u.custom && (j = u.custom(j, a, N(l.value, n))), o("div", {
            class: [P.e("editable"), P.is("editable", l.value[n])]
          }, [l.value[n] ? o(y("el-input"), {
            size: "small",
            modelValue: i.value[n],
            "onUpdate:modelValue": (p) => i.value[n] = p
          }, null) : r[g.property], l.value[n] ? o(ie, null, [
            (R == null ? void 0 : R({
              ...a,
              isEdit: N(l.value, n)
            })) || o(J, {
              list: j
            }, null)
          ]) : Q ? o("span", {
            onClick: () => {
              i.value[n] = r[g.property];
            }
          }, [Q({
            ...a,
            isEdit: N(l.value, n)
          })]) : o(y("el-icon"), {
            size: "1.2em",
            onClick: () => {
              i.value[n] = r[g.property], l.value[n] = !l.value[n];
            }
          }, {
            default: () => [o(ce, null, null)]
          })]);
        };
      }
      return o(y("el-table-column"), f, ve(v) ? v : {
        default: () => [v]
      });
    }), Y = () => o(y("el-pagination"), G({
      class: P.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: I.value,
      pageSize: F.value,
      total: q.value,
      ref: x,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, S, {
      "onUpdate:currentPage": async (c) => {
        I.value = c, await $(), b();
      },
      "onUpdate:page-size": async (c) => {
        F.value = c, await $(), b();
      }
    }), {
      default: W
    }), x = d(), U = d(), C = d(null), q = d(0), I = d(e.defaultCurrentPage || 1), F = d(e.defaultPageSize || 10), T = d(!1), b = () => {
      var v, l, i;
      T.value = !0, C.value = null;
      let c;
      e.emptyTip && (L.value = e.emptyTip, clearTimeout(c), c = setTimeout(() => {
        L.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let z;
      e.elLoadingTextTimeoutText && (O.value = e.elementLoadingText, clearTimeout(z), setTimeout(() => {
        const a = document.querySelector(".el-loading-text");
        a && (a.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const E = e.server, w = {
        [((v = e.replaceFields) == null ? void 0 : v.pageSize) || "pageSize"]: x.value.pageSize,
        [((l = e.replaceFields) == null ? void 0 : l.currentPage) || "currentPage"]: x.value.currentPage
      }, t = {}, V = {
        get: "params",
        post: "data"
      }, u = ((i = e.getConfig) == null ? void 0 : i.method) && V[e.getConfig.method.toLocaleLowerCase()];
      if (e.withPage !== !1 && (e.withPage && typeof e.withPage == "string" ? t[e.withPage] = e.withPagePath ? {
        [e.withPagePath]: w
      } : w : u && (t[u] = e.withPagePath ? {
        [e.withPagePath]: w
      } : w)), e.withQuery) {
        t[u] || (t[u] = {});
        const a = e.withQueryPath ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery;
        t[u] = {
          ...t[u],
          ...a
        };
      }
      const f = {
        url: e.getUrl,
        ...t,
        ...e.getConfig
      };
      e.stringify && f.data && (f.data = ue.stringify(f.data)), m("beforeGetData", f), E(f).then((a) => {
        m("afterGetData", a), C.value = A(e.dataPath, a), q.value = A(e.totalPath, a);
      }).catch((a) => {
        m("failToGetData", a);
      }).finally(() => {
        clearTimeout(c), clearTimeout(z), T.value = !1;
      });
    };
    e.showPagination && M(b);
    const D = {
      getData: b
    };
    return M(() => {
      D.elPagination = x.value, D.elTable = U.value;
    }), H(D), () => te(o("div", G({
      class: P.b(),
      "element-loading-text": O.value
    }, S), [o(y("el-table"), G({
      data: C.value,
      ref: U
    }, S), {
      default: () => [X(e.options)],
      append: _,
      empty: B
    }), e.showPagination && Y(), e.showLoadInGet && T.value]), [[ae("loading"), e.showLoadInGet && T.value]]);
  }
});
export {
  Re as default
};
